import 'package:dart_makeup/dart_makeup.dart';
import 'package:flutter_test/flutter_test.dart';

void main() {
  group('test make up data (double value)', () {
    test('case 1: x.0 -> x', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.0);
      expect(result, 2.toString());
    });
    test('case 2: x.00 -> x', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.00);
      expect(result, 2.toString());
    });
    test('case 3: x.01 -> x.01', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.01);
      expect(result, 2.01.toString());
    });
    test('case 4: x.000 --> x', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.000);
      expect(result, 2.toString());
    });
    test('case 5: x.001 -> x.001', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.001);
      expect(result, 2.001.toString());
    });
    test('case 6: x.00202 -> x.00202', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.00202);
      expect(result, 2.00202.toString());
    });
    test('case 7: x.002340 -> x.00234', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.002340);
      expect(result, 2.00234.toString());
    });
    test('case 8: x.1230 -> x.123', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.1230);
      expect(result, 2.123.toString());
    });
    test('case 9: x.102030 -> x.10203', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.102030);
      expect(result, 2.10203.toString());
    });
    test('case 10: x.010000 -> x.01', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.010000);
      expect(result, 2.01.toString());
    });
    test('case 11: x.0101010 -> x.010101', () async {
      String result = DartMakeUp.removeFloatingCharactersUnnecessary(2.0101010);
      expect(result, 2.010101.toString());
    });
  });

  test('compare floating point', () {
    var a = (0.3 * 3) + 0.1;
    var b = 1.0;
    bool result = false;

    if (a - b < 1e-9) {
      result = true;
    }
    expect(result, true);
  });
}
